
using System;
using System.Data;
using System.Collections.Generic;
using ZXDT.Common;
using ZXDT.CallCenter.Model;
namespace ZXDT.CallCenter.BLL
{
    /// <summary>
    /// 通话记录表
    /// </summary>
    public partial class T_Call_CallRecords
    {
        private readonly ZXDT.CallCenter.DAL.T_Call_CallRecords dal = new ZXDT.CallCenter.DAL.T_Call_CallRecords();
        public T_Call_CallRecords()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return dal.GetMaxId();
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int CallRecordsId)
        {
            return dal.Exists(CallRecordsId);
        }

        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(ZXDT.CallCenter.Model.T_Call_CallRecords model)
        {
            return dal.Add(model);
        }

        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(ZXDT.CallCenter.Model.T_Call_CallRecords model)
        {
            return dal.Update(model);
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int CallRecordsId)
        {

            return dal.Delete(CallRecordsId);
        }
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool DeleteList(string CallRecordsIdlist)
        {
            return dal.DeleteList(CallRecordsIdlist);
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public ZXDT.CallCenter.Model.T_Call_CallRecords GetModel(int CallRecordsId)
        {

            return dal.GetModel(CallRecordsId);
        }

        /// <summary>
        /// 得到一个对象实体，从缓存中
        /// </summary>
        //public ZXDT.CallCenter.Model.T_Call_CallRecords GetModelByCache(int CallRecordsId)
        //{

        //    string CacheKey = "T_Call_CallRecordsModel-" + CallRecordsId;
        //    object objModel = ZXDT.Common.DataCache.GetCache(CacheKey);
        //    if (objModel == null)
        //    {
        //        try
        //        {
        //            objModel = dal.GetModel(CallRecordsId);
        //            if (objModel != null)
        //            {
        //                int ModelCache = Maticsoft.Common.ConfigHelper.GetConfigInt("ModelCache");
        //                Maticsoft.Common.DataCache.SetCache(CacheKey, objModel, DateTime.Now.AddMinutes(ModelCache), TimeSpan.Zero);
        //            }
        //        }
        //        catch{}
        //    }
        //    return (ZXDT.CallCenter.Model.T_Call_CallRecords)objModel;
        //}

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            return dal.GetList(strWhere);
        }
        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            return dal.GetList(Top, strWhere, filedOrder);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<ZXDT.CallCenter.Model.T_Call_CallRecords> GetModelList(string strWhere)
        {
            DataSet ds = dal.GetList(strWhere);
            return DataTableToList(ds.Tables[0]);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<ZXDT.CallCenter.Model.T_Call_CallRecords> DataTableToList(DataTable dt)
        {
            List<ZXDT.CallCenter.Model.T_Call_CallRecords> modelList = new List<ZXDT.CallCenter.Model.T_Call_CallRecords>();
            int rowsCount = dt.Rows.Count;
            if (rowsCount > 0)
            {
                ZXDT.CallCenter.Model.T_Call_CallRecords model;
                for (int n = 0; n < rowsCount; n++)
                {
                    model = dal.DataRowToModel(dt.Rows[n]);
                    if (model != null)
                    {
                        modelList.Add(model);
                    }
                }
            }
            return modelList;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetAllList()
        {
            return GetList("");
        }

        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            return dal.GetRecordCount(strWhere);
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            return dal.GetListByPage(strWhere, orderby, startIndex, endIndex);
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        //public DataSet GetList(int PageSize,int PageIndex,string strWhere)
        //{
        //return dal.GetList(PageSize,PageIndex,strWhere);
        //}

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod

        #region 更新来电振铃电话记录信息

        /// <summary>
        /// 更新来电振铃电话记录信息
        /// </summary>
        public bool UpdateCallInRingTelRecord(Model.T_Call_CallRecords model)
        {
            return dal.UpdateCallInRingTelRecord(model);
        }

        #endregion

        #region 更新来电摘机电话记录信息

        /// <summary>
        /// 更新来电摘机电话记录信息
        /// </summary>
        public bool UpdateCallInAnswerTelRecord(Model.T_Call_CallRecords model)
        {
            return dal.UpdateCallInAnswerTelRecord(model);
        }

        #endregion

        #region 更新来电挂断电话记录信息

        /// <summary>
        /// 更新来电挂断电话记录信息
        /// </summary>
        public bool UpdateCallInHookTelRecord(string callId)
        {
            return dal.UpdateCallInHookTelRecord(callId);
        }

        #endregion

        #region 更新来电录音记录信息

        /// <summary>
        /// 更新来电录音记录信息
        /// </summary>
        public bool UpdateCallInPathTelRecord(Model.T_Call_CallRecords model)
        {
            return dal.UpdateCallInPathTelRecord(model);
        }

        #endregion

        #region 根据来电号码获取电话记录
        /// <summary>
        /// 根据来电号码获取电话记录
        /// </summary>
        public ZXDT.CallCenter.Model.T_Call_CallRecords GetModelByTelphone(string CallNumber)
        {

            return dal.GetModelByTelphone(CallNumber);
        }
        #endregion

        #region 根据CallId获取电话记录
        /// <summary>
        /// 根据CallId获取电话记录
        /// </summary>
        public ZXDT.CallCenter.Model.T_Call_CallRecords GetModelByCallId(string CallId)
        {

            return dal.GetModelByCallId(CallId);
        }
        /// <summary>
        /// 根据CallId获取电话记录
        /// </summary>
        public ZXDT.CallCenter.Model.T_Call_CallRecords GetModelByRecordId(string CallId)
        {

            return dal.GetModelByRecordId(CallId);
        }
        #endregion

        #region 更新来电处理状态信息

        /// <summary>
        /// 更新来电处理状态信息
        /// </summary>
        public bool UpdateCallInRecordDealType(string callid, int type)
        {
            return dal.UpdateCallInRecordDealType(callid, type);
        }

        #endregion


        #region 报表数据

        /// <summary>
        /// 获取小时分布数据
        /// </summary>
        /// <param name="StartDate">开始日期</param>
        /// <param name="EndDate">结束日期</param>
        /// <returns></returns>
        public DataTable GetHourData(string startDate, string endDate)
        {
            return dal.GetHourData(startDate, endDate);

        }
        public DataTable GetHourDataList(string CallHour, string startDate, string endDate)
        {
            return dal.GetHourDataList(CallHour, startDate, endDate);

        }
        public DataTable GetdTypeData(string dType, int? busType, string startDate, string endDate)
        {
            return dal.GetdTypeData(dType, busType, startDate, endDate);
        }
        /// <summary>
        /// 获取选择类型数据
        /// </summary>
        /// <param name="StartDate">开始日期</param>
        /// <param name="EndDate">结束日期</param>
        /// <returns></returns>
        public DataTable GetBussTypeData(string startDate, string endDate)
        {

            return dal.GetBussTypeData(startDate, endDate);
        }

        /// <summary>
        /// 获取选择类型数据
        /// </summary>
        /// <param name="StartDate">开始日期</param>
        /// <param name="EndDate">结束日期</param>
        /// <returns></returns>
        public DataTable GetWorkOrderBussTypeData(string startDate, string endDate)
        {
            return dal.GetWorkOrderBussTypeData(startDate, endDate);
        }


        public DataTable GetWorkOrderBussTypeDataRX(string startDate, string endDate)
        {
            return dal.GetWorkOrderBussTypeDataRX(startDate, endDate);
        }
        /// <summary>
        /// 获取选择类型数据
        /// </summary>
        /// <param name="StartDate">开始日期</param>
        /// <param name="EndDate">结束日期</param>
        /// <returns></returns>
        public DataTable GetWorkOrderBussTypeFromData(string startDate, string endDate)
        {
            return dal.GetWorkOrderBussTypeFromData(startDate, endDate);
        }
        public DataTable GetWorkOrderBussTypeFromDataNew(string startDate, string endDate)
        {
            return dal.GetWorkOrderBussTypeFromDataNew(startDate, endDate);
        }
        /// <summary>
        /// 获取选择类型数据
        /// </summary>
        /// <param name="StartDate">开始日期</param>
        /// <param name="EndDate">结束日期</param>
        /// <returns></returns>
        public DataTable GetWorkOrderWeekData(string startDate, string endDate)
        {
            return dal.GetWorkOrderWeekData(startDate, endDate);
        }

        /// <summary>
        /// 坐席业务量
        /// </summary>
        /// <param name="StartDate">开始日期</param>
        /// <param name="EndDate">结束日期</param>
        /// <returns></returns>
        public DataTable GetWorkOrderUeserData(string startDate, string endDate)
        {
            return dal.GetWorkOrderUeserData(startDate, endDate);
        }

        /// <summary>
        /// 分渠道业务统计
        /// </summary>
        /// <param name="StartDate">开始日期</param>
        /// <param name="EndDate">结束日期</param>
        /// <returns></returns>
        public DataTable GetWorkOrderFrom(string startDate, string endDate)
        {
            return dal.GetWorkOrderFrom(startDate, endDate);
        }

        /// <summary>
        /// 处理方式
        /// </summary>
        /// <param name="StartDate">开始日期</param>
        /// <param name="EndDate">结束日期</param>
        /// <returns></returns>
        public DataTable GetWorkOrderTrainFunction(string startDate, string endDate)
        {
            return dal.GetWorkOrderTrainFunction(startDate, endDate);
        }
        
 public DataTable GetWorkOrderTrainFunctionRX(string startDate, string endDate)
        {
            return dal.GetWorkOrderTrainFunctionRX(startDate, endDate);
        }
        public DataTable GetWorkOrderTrainFunctionRXQT(string startDate, string endDate)
        {
            return dal.GetWorkOrderTrainFunctionRXQT(startDate, endDate);
        }
        
             public DataTable GetWorkOrderTrainFunctionRXWX(string startDate, string endDate,string wbwx)
        {
            return dal.GetWorkOrderTrainFunctionRXWX(startDate, endDate,wbwx);
        }
        public DataTable GetWorkOrderTrainFunctionRXMX(string startDate, string endDate,string sql)
        {
            return dal.GetWorkOrderTrainFunctionRXMX(startDate, endDate,sql);
        }
        /// <summary>
        /// 坐席话务量
        /// </summary>
        /// <param name="StartDate">开始日期</param>
        /// <param name="EndDate">结束日期</param>
        /// <returns></returns>
        public DataTable CallTimeMath(string startDate, string endDate)
        {
            return dal.CallTimeMath(startDate, endDate);
        }




        /// <summary>
        /// 获取工单类型数据
        /// </summary>
        /// <param name="StartDate">开始日期</param>
        /// <param name="EndDate">结束日期</param>
        /// <returns></returns>
        public DataTable WorkOrderDate(string startDate, string endDate)
        {
            return dal.WorkOrderDate(startDate, endDate);
        }
        #endregion
        #region 获取在线坐席

        /// <summary>
        /// 获取在线坐席
        /// </summary>
        /// <returns></returns>
        public DataTable GetLoginUserInfo()
        {
            return dal.GetLoginUserInfo();
        }

        #endregion


        #region 获取坐席微信/微博工单数量


        /// <summary>
        /// 获取坐席微信/微博工单数量
        /// </summary>
        /// <param name="StartDate">开始日期</param>
        /// <param name="EndDate">结束日期</param>
        /// <returns></returns>
        public int WorkOrderCount(int? busType, string startDate, string endDate)
        {
            return dal.WorkOrderCount(busType, startDate, endDate);

        }


        #endregion

        /// <summary>
        /// 重新设置线路
        /// </summary>
        public bool SetLine(int F_Linenum, string CallId)
        {
            return dal.SetLine(F_Linenum, CallId);
        }

    }
}

